sreport(1)

NAME
sreport - Generate reports from the slurm accounting data.

SYNOPSIS
sreport [OPTIONS...] [COMMAND...]

DESCRIPTION
sreport is used to generate reports of job usage and cluster utilization for Slurm jobs saved to the Slurm Database, slurmdbd.

OPTIONS

-a, --all_clusters
    Use all clusters instead of only the cluster from which the command was executed.

--federation
    Generate a report for the federation if a member of one.

-h, --help
    Print a help message describing the usage of sreport.

--local
    Generate a report for the local cluster, even if part of a federation. Overrides --federation

-M, --cluster
    The cluster(s) to generate reports for. Default is local cluster, unless the local cluster is currently part of a federation and in that case generate a report for all clusters in the current federation. If the clusters included in a federation vary through time, use this option to identify the clusters to be included in report. Implies --local.

-n, --noheader
    Don't display header when listing results.

-p, --parsable
    Output will be '|' delimited with a '|' at the end.

-P, --parsable2
    Output will be '|' delimited without a '|' at the end.

-Q, --quiet
    Print no warning or informational messages, only error messages.

-t <format>
    Specify the output time format. Time format options are case insensitive and may be abbreviated. The default format is Minutes. Supported time format options are listed in the time command section below.

-T,  --tres <tres_names>
    Trackable resource (TRES) to report values for. By default CPU resource use is reported. Multiple TRES names may be separated using a comma separated list for all reports except the job reports, which can only support a single TRES name, or "ALL" for all TRES. The "Reported" Billing TRES is calculated from the largest Billing TRES of each node multiplied by the time frame. For example, if a node is part of multiple partitions and each has a different TRESBillingWeights defined the Billing TRES for the node will be the highest of the partitions. If TRESBillingWeights is not defined on any partition for a node then the Billing TRES will be equal to the number of CPUs on the node.

-v, --verbose
    Print detailed event logging.

-V , --version
    Print version information and exit.

COMMANDS

<keyword> may be omitted from the execute line and sreport will
    execute in interactive mode. sreport will process commands as entered until explicitly terminated.

exit
    Terminate the execution of sreport. Identical to the quit command.

help
    Display a description of sreport options and commands.

nonparsable
    Return output to normal after parsable or parsable2 has been set.

parsable
    Output will be | delimited with an ending '|'.

parsable2
    Output will be | delimited without an ending '|'.

quiet
    Print no warning or informational messages, only fatal error messages.

quit
    Terminate the execution of sreport. Identical to the exit command.

time <time_format>
    Specify the output time format. Time format options are case insensitive and may be abbreviated. The default format is Minutes. Supported time format options include:

    SecPer
        Seconds/Percentage of Total

    MinPer
        Minutes/Percentage of Total

    HourPer
        Hours/Percentage of Total

    Seconds
        Seconds

    Minutes
        Minutes

    Hours
        Hours

    Percent
        Percentage of Total

verbose
    Enable detailed event logging.

version
    Display the sreport version number.

!!  Repeat the last command executed.

REPORT TYPES

Valid report types are:
    cluster <REPORT> <OPTIONS> job <REPORT> <OPTIONS> reservation <REPORT> <OPTIONS> user <REPORT> <OPTIONS>

<REPORT> options for each type include:
    cluster - AccountUtilizationByUser, UserUtilizationByAccount, UserUtilizationByWckey, Utilization, WCKeyUtilizationByUser job - SizesByAccount, SizesByAccountAndWcKey, SizesByWckey reservation - Utilization user - TopUsage

REPORT DESCRIPTION

cluster AccountUtilizationByUser
    This report will display account utilization as it appears on the hierarchical tree. Starting with the specified account or the root account by default this report will list the underlying usage with a sum on each level. Use the 'tree' option to span the tree for better visibility. NOTE: If there were reservations allowing a whole account any idle time in the reservation given to the association for the account, not the user associations in the account, so it can be possible a parent account can be larger than the sum of it's children.

cluster UserUtilizationByAccount
    This report will display users by account in order of utilization without grouping multiple accounts by user into one, but displaying them on separate lines.

cluster UserUtilizationByWCKey
    This report will display users by wckey in order of utilization without grouping multiple wckey by user into one, but displaying them on separate lines.

cluster Utilization
    This report will display total usage divided by Allocated, Down, Idle, and Reserved time for selected clusters. Reserved time refers to time that a job was waiting for resources after the job had become eligible. If the value is not of importance for you the number should be grouped with idle time.

cluster WCKeyUtilizationByUser
    This report will display wckey utilization sorted by WCKey name for each user on each cluster.

job SizesByAccount
    This report will display the amount of time used for job ranges specified by the 'grouping=' option. Only a single level in the tree is displayed defaulting to the root dir. If you specify other accounts with the 'account=' option sreport will use those accounts as the root account and you will receive the sub accounts for the accounts listed.

job SizesByAccountAndWckey
    This report is very similar to SizesByAccount with the difference being each account is pair with wckeys so the identifier is account:wckey instead of just account so there will most likely be multiple accounts listed depending on the number of wckeys used.

job SizesByWckey
    This report will display the amount of time for each wckey for job ranges specified by the 'grouping=' option.

reservation Utilization
    This report will display total usage for reservations on the systems.

user TopUsage
    Displays the top users on a cluster. Use the group option to group accounts together. The default is to have a different line for each user account combination.

Each report type has various options...

OPTIONS FOR ALL REPORT TYPES

All_Clusters
    Use all monitored clusters. Default is local cluster.

Clusters=<OPT>
    List of clusters to include in report. Default is local cluster.

End=<OPT>
    Period ending for report. Default is 23:59:59 of previous day. Valid time formats are...

    HH:MM[:SS] [AM|PM]
    MMDD[YY] or MM/DD[/YY] or MM.DD[.YY]
    MM/DD[/YY]-HH:MM[:SS]
    YYYY-MM-DD[THH:MM[:SS]]

Format=<OPT>
    Comma separated list of fields to display in report. When using the format option for listing various fields you can put a %NUMBER afterwards to specify how many characters should be printed. e.g. format=name%30 will print 30 characters of field name right justified. A -30 will print 30 characters left justified.

Start=<OPT>
    Period start for report. Default is 00:00:00 of previous day. Valid time formats are...

    HH:MM[:SS] [AM|PM]
    MMDD[YY] or MM/DD[/YY] or MM.DD[.YY]
    MM/DD[/YY]-HH:MM[:SS]
    YYYY-MM-DD[THH:MM[:SS]]

OPTIONS SPECIFICALLY FOR CLUSTER REPORTS

Accounts=<OPT>
    When used with the UserUtilizationByAccount, or AccountUtilizationByUser, List of accounts to include in report. Default is all.

Tree
    When used with the AccountUtilizationByUser report will span the accounts as they are in the hierarchy.

Users=<OPT>
    When used with any report other than Utilization, List of users to include in report. Default is all.

Wckeys=<OPT>
    When used with the UserUtilizationByWckey or WCKeyUtilizationByUser, List of wckeys to include in report. Default is all.

OPTIONS SPECIFICALLY FOR JOB REPORTS

Accounts=<OPT>
    List of accounts to use for the report Default is all. The SizesByAccount(*) report only displays 1 hierarchical level. If accounts are specified the next layer of accounts under those specified will be displayed, not the accounts specified. In the SizesByAccount(*) reports the default for accounts is root. This explanation does not apply when ran with the FlatView option.

FlatView
    When used with the SizesbyAccount(*) will not group accounts in a hierarchical level, but print each account where jobs ran on a separate line without any hierarchy.

GID=<OPT>
    List of group ids to include in report. Default is all.

Grouping=<OPT>
    Comma separated list of size groupings. (e.g. 50,100,150 would group job cpu count 1-49, 50-99, 100-149, > 150). grouping=individual will result in a single column for each job size found.

Jobs=<OPT>
    List of jobs/steps to include in report. Default is all.

Nodes=<OPT>
    Only show jobs that ran on these nodes. Default is all.

Partitions=<OPT>
    List of partitions jobs ran on to include in report. Default is all.

PrintJobCount
    When used with the Sizes report will print number of jobs ran instead of time used.

Users=<OPT>
    List of users jobs to include in report. Default is all.

Wckeys=<OPT>
    List of wckeys to use for the report. Default is all. The SizesbyWckey report all users summed together. If you want only certain users specify them them with the Users= option.

OPTIONS SPECIFICALLY FOR RESERVATION REPORTS

Names=<OPT>
    List of reservations to use for the report. Default is all.

Nodes=<OPT>
    Only show reservations that used these nodes. Default is all.

OPTIONS SPECIFICALLY FOR USER REPORTS

Accounts=<OPT>
    List of accounts to use for the report. Default is all.

Group
    Group all accounts together for each user. Default is a separate entry for each user and account reference.

TopCount=<OPT>
    Used in the TopUsage report. Change the number of users displayed. Default is 10.

Users=<OPT>
    List of users jobs to include in report. Default is all.

FORMAT OPTIONS FOR EACH REPORT
FORMAT OPTIONS FOR CLUSTER REPORTS
AccountUtilizationByUser:
UserUtilizationByAccount:
Accounts, Cluster, Login, Proper, TresCount, Used
UserUtilizationByWckey:
WCKeyUtilizationByUser:
Cluster, Login, Proper, TresCount, Used, Wckey
Utilization:
Allocated, Cluster, Down, Idle, Overcommited, PlannedDown, Reported, Reserved, TresCount, TresName

FORMAT OPTIONS FOR JOB REPORTS
    SizesByAccount, SizesByAccountAndWckey:
    Account, Cluster
    SizesByWckey:
    Wckey, Cluster

FORMAT OPTIONS FOR RESERVATION REPORTS
    Utilization:
    Allocated, Associations, Cluster, End, Flags, Idle, Name, Nodes, ReservationId, Start, TotalTime, TresCount, TresName, TresTime

FORMAT OPTIONS FOR USER REPORTS
    TopUsage:
    Account, Cluster, Login, Proper, Used

All commands and options are case-insensitive.

ENVIRONMENT VARIABLES

Some sreport options may be set via environment variables. These environment variables, along with their corresponding options, are listed below. (Note: commandline options will always override these settings)

SREPORT_CLUSTER
    Same as -M, --cluster

SREPORT_FEDERATION
    Same as --federation

SREPORT_LOCAL
    Same as --local

SREPORT_TRES
    Same as -t, --tres

SLURM_CONF
    The location of the Slurm configuration file.

EXAMPLES

sreport job sizesbyaccount

sreport cluster utilization

sreport user top

sreport job sizesbyaccount All_Clusters users=gore1 account=environ PrintJobCount
    Report number of jobs by user gore1 within the environ account

sreport cluster AccountUtilizationByUser cluster=zeus user=gore1 start=2/23/08 end=2/24/09 format=Accounts,Cluster,TresCount,Login,Proper,Used
    Report cluster account utilization with the specified fields during the specified 24 hour day of February 23, 2009, by user gore1

sreport cluster AccountUtilizationByUser cluster=zeus accounts=lc start=2/23/08 end=2/24/09
    Report cluster account utilization by user in the LC account on cluster zeus

sreport user topusage start=2/16/09 end=2/23/09 -t percent account=lc
    Report top usage in percent of the lc account during the specified week

COPYING
Copyright (C) 2009-2010 Lawrence Livermore National Security. Produced at Lawrence Livermore National Laboratory (cf, DISCLAIMER).
Copyright (C) 2010-2015 SchedMD LLC.

This file is part of Slurm, a resource management program. For details, see <https://slurm.schedmd.com/>.

Slurm is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

Slurm is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

SEE ALSO
sacct(1), slurmdbd(8)